import { Serializable } from 'child_process';
import { RunningTask } from '../../tasks-runner/running-tasks/running-task';
import { ExecutorContext } from '../../config/misc-interfaces';
import { NormalizedRunCommandsOptions } from './run-commands.impl';
import { PseudoTerminal } from '../../tasks-runner/pseudo-terminal';
export declare class ParallelRunningTasks implements RunningTask {
    private readonly childProcesses;
    private readyWhenStatus;
    private readonly streamOutput;
    private exitCallbacks;
    constructor(options: NormalizedRunCommandsOptions, context: ExecutorContext);
    getResults(): Promise<{
        code: number;
        terminalOutput: string;
    }>;
    onExit(cb: (code: number, terminalOutput: string) => void): void;
    send(message: Serializable): void;
    kill(signal?: NodeJS.Signals | number): Promise<void>;
    private run;
}
export declare class SeriallyRunningTasks implements RunningTask {
    private pseudoTerminal?;
    private terminalOutput;
    private currentProcess;
    private exitCallbacks;
    private code;
    private error;
    constructor(options: NormalizedRunCommandsOptions, context: ExecutorContext, pseudoTerminal?: PseudoTerminal);
    getResults(): Promise<{
        code: number;
        terminalOutput: string;
    }>;
    onExit(cb: (code: number, terminalOutput: string) => void): void;
    send(message: Serializable): void;
    kill(signal?: NodeJS.Signals | number): void | Promise<void>;
    private run;
    private createProcess;
}
